	page	,132
;
;LOAD------Kantronics, Inc. 15 Sep 84
;load program  converts a .HEX program to a .COM program
;error checking is at a minimum
;
makef	equ	016h
wrtf	equ	015h
closf	equ	010h
readf	equ	014h
openf	equ	0fh
code	segment
	assume	cs:code,ds:code,es:code
	org	05ch
fcb1	db	?
	org	080h
buff1	db	?
	org	0100h
begin:	cld
	mov	si,offset fcb1
	mov	di,offset fcb2
	mov	cx,9
	rep movsb	;move filename to fcb2
	mov	di,si	;force fcb1 to be a .HEX file
	mov	ax,'EH'
	stosw
	mov	al,'X'
	stosb
	mov	ah,openf	;open .HEX file
	mov	dx,offset fcb1
	int	021h
	and	al,al
	jz	open2
	mov	ah,9	;file not found
	mov	dx,offset error1
	int	021h
	int	020h
open2:	mov	fcb1+32,al	;create .COM file
	mov	ah,makef
	mov	dx,offset fcb2
	int	021h
	mov	byte ptr fcb2+32,0
	mov	addr,0100h	;initialize pointers
	mov	point1,offset buff1+127
	mov	point2,offset buff2
main:	call	getb	;look for start of hex line
	jz	mainx
	cmp	al,':'
	jz	main1
	cmp	al,01ah
	jnz	main
mainx:	cmp	point2,offset buff2	;end of .HEX file
	jz	mainz
	mov	al,0	;write last 128 bytes to .COM file
	call	writeb
	jmp	mainx
mainz:	mov	ah,closf	;close .COM file
	mov	dx,offset fcb2
	int	021h
	int	020h	;end
;
main1:	mov	byte ptr check,0	;clear checksum
	call	getbc	;get number of bytes in this record
	cmp	al,0
	jz	mainx	;if zero, must be end of file
	mov	byte ptr bytcnt,al
	call	getbc	;get starting address of this record
	mov	ch,al
	call	getbc
	mov	cl,al
	call	getbc	;throw away 00
main2:	cmp	cx,addr
	jz	main3
	mov	al,0	;fill gaps between records with zeroes
	call	writeb
	inc	addr
	jmp	main2
main3:	call	getbc	;get hex double byte
	call	writeb	;write byte to .COM file
	inc	addr
	dec	byte ptr bytcnt
	jnz	main3
	call	getbc	;add checksum
	mov	al,check	;checksum should now be zero if ok
	and	al,al
	jz	main
	mov	dx,offset error2
	mov	ah,9
	int	021h
	jmp	mainx
;
writeb:	mov	di,point2	;put byte in buffer2
	mov	byte ptr [di],al
	inc	di
	cmp	di,offset buff2+080h
	jnz	wrtx
	mov	dx,offset buff2	;buffer full, set dma address to buffer2
	mov	ah,01ah
	int	021h
	mov	dx,offset fcb2	;write buffer to .COM file
	mov	ah,wrtf
	int	021h
	mov	dx,080h	;reset dma address to buffer 1
	mov	ah,01ah
	int	021h
	mov	di,offset buff2
wrtx:	mov	point2,di
	ret
;
getbc:	call	getbh	;convert two hex digits to one byte
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1
	mov	bl,al
	call	getbh
	or	al,bl
	add	byte ptr check,al	;add byte to checksum
	ret
;
getbh:	call	getb	;convert alphanumeric to hex nibble
	cmp	al,'A'	;note::::no error checking done
	jb	getbhx
	sub	al,7
getbhx:	and	al,0fh
	ret
;
getb:	mov	di,point1	;get char from input buffer 1
	inc	di
	cmp	di,offset buff1+128
	jnz	getbx
	mov	ah,readf	;buffer empty, read in next 128 bytes
	mov	dx,offset fcb1
	int	021h
	mov	di,offset buff1
	cmp	al,1
	jz	getbz
getbx:	mov	al,[di]
	mov	point1,di
getbz:	ret
;
error1	db	'file not found$'
error2	db	'checksum error$'
;
addr	dw	?
point1	dw	?
point2	dw	?
check	db	?
bytcnt	db	?
;
fcb2	db	9 dup(?)
	db	'COM'
	db	24 dup(0)
buff2	db	128 dup (0)
;
code	ends
	end	begin
